// Copyright 1998 by Patrik Simons
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston,
// MA 02111-1307, USA.
//
// Patrik.Simons@hut.fi
#include "parser.h"

using namespace std;

void usage ()
{
  cerr << "Pparse version 1.19" << endl;
  cerr << "Usage: pparse [--rule-atoms]" << endl;
  cerr << "       --rule-atoms adds an atom for every rule so that smodels can" << endl;
  cerr << "                    take the rules as choice points." << endl;
  cerr << "Pparse is a filter" << endl;
}

int main (int argc, char **argv)
{
  bool rule_atoms = false;
  if (argc == 2 and strncmp(argv[1], "--rule-atoms", sizeof("--rule-atoms")) == 0)
    rule_atoms = true;
  else if (argc > 1)
    {
      usage ();
      return 1;
    }
  Parser p (cout);
  p.rule_atoms = rule_atoms;
  if (p.program () == Error)
    return 1;
  p.print ();
  return 0;
}

